from tokenize import String
from rest_framework.response import Response
from rest_framework.decorators import api_view
from rest_framework import serializers
import pandas as pd
import sqlite3
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
import math

# Create your views here.

@api_view(['GET'])
def getData(request):
    # Loading the Dataset
    DateSet = pd.read_csv("assets/csv/covid.csv", skipinitialspace=True)


    # variables
    x = DateSet[['Fever', 'Headache', 'Dry_Cough','Sore_throat', 'Breathing_Problem']]
    y = DateSet['covid_result']


    # train test split
    x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.3, random_state=2)

    # LinearRegression algorithm
    LR = LinearRegression()
    LR.fit(x_train, y_train)

    Fever = 1
    Headache = 0
    Dry_Cough = 1
    Sore_throat = 1
    Breathing_Problem = 0

    new_input = [[int(Fever),int(Headache),int(Dry_Cough),int(Sore_throat),int(Breathing_Problem)]]

    Predicted_value = LR.predict(x)
    Predicted_covid = LR.predict(new_input)

    print (Predicted_covid)

    return Response(math.ceil(Predicted_covid[0]*100)/100)

@api_view(['POST'])
def addItem(request):
    val = request.data
    print(val['fever'])
    print(val['headache'])

    DateSet = pd.read_csv("assets/csv/covid.csv", skipinitialspace=True)


    # variables
    x = DateSet[['Fever', 'Headache', 'Dry_Cough','Sore_throat', 'Breathing_Problem']]
    y = DateSet['covid_result']


    # train test split
    x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.3, random_state=2)

    # LinearRegression algorithm
    LR = LinearRegression()
    LR.fit(x_train, y_train)

    Fever = 1
    Headache = 0
    Dry_Cough = 1
    Sore_throat = 1
    Breathing_Problem = 0


    if val['fever'] == "Yes":
        val_fever = 1
    else:
        val_fever = 0

    if val['headache'] == "Yes":
        val_headache = 1
    else:
        val_headache = 0

    if val['dry_cough'] == "Yes":
        val_dry_cough = 1
    else:
        val_dry_cough = 0 

    if val['sor_throt'] == "Yes":
        val_sor_throt = 1
    else:
        val_sor_throt = 0  

    if val['breathing_problem'] == "Yes":
        val_breathing_problem = 1
    else:
        val_breathing_problemt = 0  

    new_input = [[int(val_fever),int(val_headache),int(val_dry_cough),int(val_sor_throt),int(val_breathing_problem)]]    

    Predicted_value = LR.predict(x)
    Predicted_covid = LR.predict(new_input)

    # print (Predicted_covid)

    return Response(math.ceil(Predicted_covid[0]*100)/100)

    # con = sqlite3.connect("db.sqlite3")
    # df = pd.read_sql_query("SELECT * from covidapi_covid", con)
    # rslt_df = df.loc[(df['Fever'] == val['fever']) & (df['Headache'] == val['headache']) & (df['Dry_Cough'] == val['dry_cough']) & (df['Sore_throat'] == val['sor_throt']) & (df['Breathing_Problem'] == val['breathing_problem'])& (df['covid_result'] == "Yes")] 
    # print(rslt_df.shape[0])
    # return Response(rslt_df.shape[0])
